#!/usr/local/bin/perl
use strict;
use warnings;
use lib './gen-perl/';

use Thrift;
use Thrift::BinaryProtocol;
use Thrift::Socket;
use Thrift::BufferedTransport;

use Bookmark;

my $transport = Thrift::BufferedTransport->new(
    Thrift::Socket->new('localhost', 9090),
    10240,
    10240
);

my $client = BookmarkClient->new( Thrift::BinaryProtocol->new($transport) );

$transport->open();

printf "%s\n", $_->url for @{$client->bookmarks()};

$transport->close();
