// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "Bookmark.h"
#include <protocol/TBinaryProtocol.h>
#include <server/TSimpleServer.h>
#include <transport/TServerSocket.h>
#include <transport/TTransportUtils.h>

using namespace facebook::thrift;
using namespace facebook::thrift::protocol;
using namespace facebook::thrift::transport;
using namespace facebook::thrift::server;

using boost::shared_ptr;

class BookmarkHandler : virtual public BookmarkIf {
    std::vector<Entry> entries;
public:
    BookmarkHandler() {
        Entry yahoo, google;
        
        yahoo.id    = 1;
        yahoo.url   = "http://www.yahoo.com/";
        yahoo.title = "Yahoo!";

        google.id  = 2;
        google.url = "http://www.google.com/";
        google.title = "Google";

        entries.push_back( yahoo );
        entries.push_back( google );
    }
    
    void bookmarks(std::vector<Entry> & _return) {
        std::vector<Entry>::iterator it = entries.begin();
        while (it != entries.end()) {
            _return.push_back(*it);
            it++;
        }
    }
};

int main(int argc, char **argv) {
  int port = 9090;
  shared_ptr<BookmarkHandler> handler(new BookmarkHandler());
  shared_ptr<TProcessor> processor(new BookmarkProcessor(handler));
  shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
  shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
  shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

  TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
  server.serve();
  return 0;
}

