#!/usr/local/bin/perl
use strict;
use warnings;
use lib './gen-perl/';

use Thrift;
use Thrift::BinaryProtocol;
use Thrift::Socket;
use Thrift::BufferedTransport;

use Calc;

my $transport = Thrift::BufferedTransport->new(
    Thrift::Socket->new('localhost', 9090),
    10240,
    10240
);

my $client = CalcClient->new( Thrift::BinaryProtocol->new($transport) );
$transport->open();

printf "%d\n", $client->sum([ 1, 2, 3, 4, 5 ]);
printf "%d\n", $client->multi([ 1, 2, 3, 4, 5 ]);

$transport->close();
