// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "Calc.h"
#include <protocol/TBinaryProtocol.h>
#include <server/TSimpleServer.h>
#include <transport/TServerSocket.h>
#include <transport/TTransportUtils.h>

using namespace facebook::thrift;
using namespace facebook::thrift::protocol;
using namespace facebook::thrift::transport;
using namespace facebook::thrift::server;

using boost::shared_ptr;

class CalcHandler : virtual public CalcIf {
 public:
  CalcHandler() {
    // Your initialization goes here
  }

  int32_t sum(const std::vector<int32_t> & numbers) {
      int32_t result = 0;
      std::vector<int32_t>::const_iterator it = numbers.begin();
      while (it != numbers.end()) {
          result += *it;
          it++;
      }
      return result;
  }

  int32_t multi(const std::vector<int32_t> & numbers) {
      int32_t result = 1;
      std::vector<int32_t>::const_iterator it = numbers.begin();
      while (it != numbers.end()) {
          result *= *it;
          it++;
      }
      return result;
  }
};

int main(int argc, char **argv) {
  int port = 9090;
  shared_ptr<CalcHandler> handler(new CalcHandler());
  shared_ptr<TProcessor> processor(new CalcProcessor(handler));
  shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
  shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
  shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

  TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
  server.serve();
  return 0;
}

