// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "Hello.h"
#include <protocol/TBinaryProtocol.h>
// #include <server/TSimpleServer.h>
// #include <server/TNonblockingServer.h>
#include <transport/TServerSocket.h>
#include <transport/TTransportUtils.h>

#include <concurrency/ThreadManager.h>
#include <concurrency/PosixThreadFactory.h>
#include <server/TThreadPoolServer.h>

using namespace facebook::thrift;
using namespace facebook::thrift::protocol;
using namespace facebook::thrift::transport;
using namespace facebook::thrift::server;

/*  */
using namespace facebook::thrift::concurrency;

using boost::shared_ptr;

class HelloHandler : virtual public HelloIf {
public:
    HelloHandler() {
        // Your initialization goes here
    }

    void hello(std::string& _return, const std::string& name) {
        // Your implementation goes here
        _return.append("Hello ").append(name);
    }

};

int main(int argc, char **argv) {
    int port = 9090;
    shared_ptr<HelloHandler> handler(new HelloHandler());
    shared_ptr<TProcessor> processor(new HelloProcessor(handler));
    shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
    shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
    shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

    /* changes for threaded server */
    shared_ptr<ThreadManager> threadManager(ThreadManager::newSimpleThreadManager(10));
    shared_ptr<PosixThreadFactory> threadFactory(new PosixThreadFactory());
    threadManager->threadFactory(threadFactory);
    threadManager->start();
    TThreadPoolServer server(processor, serverTransport, transportFactory, protocolFactory, threadManager);
    server.serve();
    
    return 0;
}

